/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	v1 "github.com/nokia/danm/crd/apis/danm/v1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// TenantConfigLister helps list TenantConfigs.
type TenantConfigLister interface {
	// List lists all TenantConfigs in the indexer.
	List(selector labels.Selector) (ret []*v1.TenantConfig, err error)
	// Get retrieves the TenantConfig from the index for a given name.
	Get(name string) (*v1.TenantConfig, error)
	TenantConfigListerExpansion
}

// tenantConfigLister implements the TenantConfigLister interface.
type tenantConfigLister struct {
	indexer cache.Indexer
}

// NewTenantConfigLister returns a new TenantConfigLister.
func NewTenantConfigLister(indexer cache.Indexer) TenantConfigLister {
	return &tenantConfigLister{indexer: indexer}
}

// List lists all TenantConfigs in the indexer.
func (s *tenantConfigLister) List(selector labels.Selector) (ret []*v1.TenantConfig, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.TenantConfig))
	})
	return ret, err
}

// Get retrieves the TenantConfig from the index for a given name.
func (s *tenantConfigLister) Get(name string) (*v1.TenantConfig, error) {
	obj, exists, err := s.indexer.GetByKey(name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1.Resource("tenantconfig"), name)
	}
	return obj.(*v1.TenantConfig), nil
}
